<?php
function enregperte($case,$joueur1,$joueur2){
/*
Fonction qui enregistre les fichiers lorsqu'un joueur a perdu.
*/
	$date=date('d/m/y');
	$perdunoir=1;
	$perdublanc=1;
	for ($i=0;$i<64;$i++)
	{
		if ($case[$i]==='rn')
			$perdunoir=0;
		if ($case[$i]==='rb')
			$perdublanc=0;
	}
//calcule les pertes
	$uneperte=0;
	if ($perdublanc===1)
	{
		$file1='../logins/'.$joueur2.'.php';
		$file2='../logins/'.$joueur1.'.php';
		$uneperte=1;
	}else if ($perdunoir===1)
	{
		$file1='../logins/'.$joueur1.'.php';
		$file2='../logins/'.$joueur2.'.php';
		$uneperte=1;
	}
	if ($uneperte===1)
	{
		include('../partieslogs.php');
		$fp=fopen('../partieslogs.php','w');
		if ($perdublanc!==1){
			$nombre_parties_win_with_whites++;
			$couleur='blancs';
		}
		if ($perdunoir!==1){
			$couleur='noirs';
			$nombre_parties_win_with_blacks++;
		}
		fputs($fp,'<?php
                $nombre_parties_win_with_blacks='.$nombre_parties_win_with_blacks.';
                $nombre_parties_win_with_whites='.$nombre_parties_win_with_whites.';
		$parties=array(');
		foreach ($parties as $a)
			fputs($fp,'\''.$a.'\',');
		fputs($fp,'\''.$date.', '.$couleur.'\');
                ?>');
		fclose($fp);
//Sauvegarde du premier fichier
		include($file2);
		$a=file($file2);
		$fp=fopen($file2,'w');
		$partielose++;
		foreach ($a as $b)
			if (substr($b,0,strlen('$partielose'))!=='$partielose')
				fputs($fp,$b);
			else
				fputs($fp,'$partielose='.$partielose.';
				');
		fclose($fp);
//Sauvegarde du second fichier
		include($file1);
		$a=file($file1);
		$partiewin++;
		$fp=fopen($file1,'w');
		foreach ($a as $b)
			if (substr($b,0,strlen('$partiewin'))!=='$partiewin')
				fputs($fp,$b);
			else
				fputs($fp,'$partiewin='.$partiewin.';
                                ');
		fclose($fp);
	}
}

function isinchess($case, $couleur, $coupsjoues){
	/*
	Fonction qui dtermine si la couleur est en chec
	*/
//echo "couleur :$couleur<hr>\n";
	for ($i=0;$i<64;$i++)
		if ($case[$i]==='r'.$couleur)
			if (peutprendre($case,$i,$couleur, $coupsjoues)===true)
				return 1;
				//echo "ECHEC";
	return 0;
}

function etat($case, $couleur, $coupsjoues){
	/*
	for ($i=0;$i<64;$i++){
		if ($case[$i]=='rb')
			return 5;
		if ($case[$i]=='rn')
			return 5;
	}
	*/
	if ($couleur==='blancs')
		/*On a besoin de a pour savoir  qui apartient une pice...*/
		$coul='b';
	else
		$coul='n';
	$piece=array(16);
	$nbrpiece=0;
	for ($i=0;$i<64;$i++)
		if (substr($case[$i],1,1)===$coul)
		{
			$piece[$nbrpiece]=$i;
			$nbrpiece++;
			if ($nbrpiece===16)
				$i=65;
		}
	if ($nbrpiece<16){
		$piece[$nbrpiece]=65;
		if ($nbrpiece<3){
			$pat=1;
			for ($i=0;$i<64;$i++)
			{
				$a=substr($case[$i],0,1);
				$c=substr($case[$i],1,1);
				if ($a==='d' || $a==='t' || $a==='p')
				{
					$pat=0;
					$i=65;
				}
				if ($c!==$coul)
					if ($a==='f' || $a==='c')
					{
						if ($pat===2){
							$pat=0;
							$i=65;
						}else
							$pat=2;
					}
			}
			if ($pat==1)
				return 3;
		}
	}
	if (isinchess($case, $coul, $coupsjoues)===1)
	{
//Si il y a chec alors on va chercher a savoir si il y a mat
		for ($i=0;$i<$nbrpiece;$i++)
			for ($j=0;$j<64;$j++)
				if ($piece[$i] !== $j)
					if (possible(1, $couleur,$case, $piece[$i], $j, $coupsjoues)!==0)
						//echo $piece[$i].' '.$j;
						return 1;
		return 2;
//Si la fonction arrive ici, c'est que l'on ne peut pas bouger snas rester en chec (dfinition du mat)
	}else{
//Si on est pas en chec alors on doit tester si on peut bouger (au cas ou on ne peut pas alors il faut dclarer le pat...)
		for ($i=0;$i<$nbrpiece;$i++)
			for ($j=0;$j<64;$j++)
				if ($piece[$i] !== $j)
					if (possible(1, $couleur,$case, $piece[$i], $j, $coupsjoues)!==0)
						return 0;
		return 3;
	}
}

function peutprendre($case, $jusqua, $couleur, $coupsjoues){
/*
Fonction qui indique si une case peut tre prise, elle sert pour les roques et les cheques/checs et mats
*/
	if ($couleur==='b'){
		$sujoueur='noirs';
		$couleuropposee='n';
	}else{
		$sujoueur='blancs';
		$couleuropposee='b';
	}
	for ($i=0;$i<64;$i++){
		if (substr($case[$i],1,1)===$couleuropposee )
		{
//echo "Pice adverse en $i<br>\n";
			if (possible(2, $sujoueur,$case, $i, $jusqua, $coupsjoues)===1){
				return true;
			}
		}
	}
	return false;
}

function possible($doitverifchess, $couleurdujoueur,$case, $de, $jusqua, $coupsjoues){
	/*
	$couleurdujoueur sera "blancs" ou "noirs"
	$case est un tableau de 64 cases ou l'on mettra les pices
	$de est la case de dpart (nombre compris entre 0 et 63 =x+y*8... ou x et y sont compris entre 0 et 7)
	$jusqua est aussi un numro de case, mais la case d'arrive
	$coupsjoues est le tableau qui contient tout les coups jous depuis le dbut
	(sert pour les prises en passant et les roques)
	Teste si le coup pass en paramrte est valide...
	si il ne l'est pas, le retour de la fonction sera 0
	si le retour de la fonction est 1 alors c'est un coup simple
	si le retour dela fonction est 2 alors c'est une prise en passant
	si le reotur de la fonction est 3 alors c'est un petit roque
	si le retour de la fonction est 4 alors c'est un grand roque
	*/
	
	//commence par chercher si il manque un roi...
	$perdu=0;
	for ($i=0;$i<64;$i++){
		if ($case[$i]==='rn')
			$perdu++;
		if ($case[$i]==='rb')
			$perdu++;
	}
	if ($perdu!=2)
		return 0;
	$possible=1;
	$couleur=substr($case[$de],1,1);
	$couleur2=substr($case[$jusqua],1,1);
	$piece=substr($case[$de],0,1);
	//Si il est en chec aprs alors il n'a pas le droit de jouer le coup...
	$case2=joue($case, $de, $jusqua, $possible, $couleur);
	if ($doitverifchess===1)
		if (isinchess($case2, $couleur, $coupsjoues)==1)
			return 0;
	//On ne peut pas prendre une pice de sa couleur
	if ($couleur===$couleur2)
		return 0;
	if (
		($couleur==='n' && $couleurdujoueur!=='noirs') ||
		($couleur==='b' && $couleurdujoueur!=='blancs') ||
		($couleur==='o')
		)
		return 0;
//echo "Couleurs diffrentes...<br>";
//Si il n'y a pas de dplacement alors ce n'est pas bon
	if ($de===$jusqua)
		return 0;
//calculs des coordones de dpart
	$xd=$de%8;
	$yd=($de-$xd)/8;
//des d'arrives
	$xa=$jusqua%8;
	$ya=($jusqua-$xa)/8;
//echo "($xd, $yd)-($xa, $ya)<br>";
	if ($piece==='t'){
//Si la pice esst une Tour
//echo "tour<br>";
		if ($xd===$xa)
		{
//Si la tour se dplace en ordone
			if ($yd > $ya)
			{
//On tri (pour la boucle)
				$a=$ya;
				$ya=$yd;
				$yd=$a;
			}
//On vrifie qu'il n'y a rien sur le passage de la tour
			for ($a=$yd+1;$a<$ya;$a++)
				if ($case[$a*8+$xa]!='no')
					return 0;
		}else if ($yd===$ya){
//Si la tour se dplace en abscisse
			if ($xd > $xa){
//on tri (pour la boucle)
				$a=$xa;
				$xa=$xd;
				$xd=$a;
			}
			for ($a=$xd+1;$a<$xa;$a++){
//On vrifie qu'il n'y a rien sur le pasage de la tour
				if ($case[$ya*8+$a]!=='no'){
					return 0;
				}
			}
		}else{
			return 0;
		}
	}else if($piece==='c'){
//Si c'est un cavalier
//echo "Cavalier<br>";
//Le cavalier a huit cases pour se dplacer...
		if (
		(($xd===$xa+2)&&($yd===$ya+1))||
		(($xd===$xa+2)&&($yd===$ya-1))||
		(($xd===$xa-2)&&($yd===$ya+1))||
		(($xd===$xa-2)&&($yd===$ya-1))||
		(($xd===$xa+1)&&($yd===$ya+2))||
		(($xd===$xa+1)&&($yd===$ya-2))||
		(($xd===$xa-1)&&($yd===$ya+2))||
		(($xd===$xa-1)&&($yd===$ya-2))
		){
		}else{
			return 0;
		}
	}else if($piece==='f'){
//Si c'est un fou
//echo "Fou<br>";
		$taille=abs($xd-$xa);
//echo "taille : $taille<br>";
		if ($taille===abs($yd-$ya)){
			if ($xd<$xa){
				$sensa=1;
			}else{
				$sensa=-1;
			}
			if ($yd<$ya){
				$sensb=1;
			}else{
				$sensb=-1;
			}
			$a=$xd+$sensa;
			$b=$yd+$sensb;
			for ($i=0;$i<$taille-1;$i++){
//echo "$a, $b <br>";
				if ($case[$b*8+$a]!=='no')
					return 0;
/*
$j=$case[$b*8+$a];
echo "$j en ($a, $b)<br>";
*/
				$a+=$sensa;
				$b+=$sensb;
			}
		}else
//echo "Vous n'allez ps en diagonale<br>";
			return 0;
//Si c'est un roi
	}else if($piece==='r'){
//echo "Roi<br>";
//Le Roi a huit cases pour se dplacer
		if (
		(($xd===$xa+1)&&($yd===$ya+1))||
		(($xd===$xa+1)&&($yd===$ya-1))||
		(($xd===$xa+1)&&($yd===$ya))||
		(($xd===$xa)&&($yd===$ya+1))||
		(($xd===$xa)&&($yd===$ya-1))||
		(($xd===$xa-1)&&($yd===$ya+1))||
		(($xd===$xa-1)&&($yd===$ya-1))||
		(($xd===$xa-1)&&($yd===$ya))
		){
		}else{
			$possible=0;
//On commence par mettre la variable, ensuite on mets les possibilits de roque...
			if ( $ya===$yd){
//echo "ROQUES";
				if ($couleur==='b'){
					$roi=60;
					$t1=56;
					$t2=63;
//echo "blancs";
				}else{
					$roi=4;
					$t1=0;
					$t2=7;
//echo "noirs";
				}
//echo "$case[$roi] r$couleur";
				if ( $xa === $xd - 2 && $case[$roi]==='r'.$couleur && $case[$t1]==='t'.$couleur){
					$possible=3;
//echo "Petit roque";
				}else if ($xa === $xd + 2 && $case[$roi]==='r'.$couleur && $case[$t2]==='t'.$couleur){
					$possible=4;
//echo "Grand roque";
				}else{
//echo "oulala... Coup illgal";
				}
				if ($possible!==0){
					$i=1;
					foreach ($coupsjoues as $coup){
						$i++;
						if (($i%2===0 && $couleur==='b') || ($i%2===1 && $couleur==='n')){
							$p2=substr($coup, 0, 1);
//Rcupres le nom et les coordonnes de la pice
							$xd2=substr($coup, 2, 1);
							$yd2=substr($coup, 4, 1);
							if ($p2==='r'){
//Si le roi a dja boug alors on ne peut plus roquer
								return 0;
							}else if ($p2==='t' && ( ($possible===3 && $t1===$xd2+$yd2*8)||($possible===4 && $t2===$xd2+$yd2*8) ) ){
								return 0;
//Se la tour a dja bouge alors on ne peut plus roquer
							}
						}
					}
				}
			}
		}
	}else if($piece==='d'){
//Si c'est une dame
//echo "Dame<br>";
		$taille=abs($xd-$xa);
//echo "taille : $taille<br>";
		if ($taille===abs($yd-$ya)){
//cherches si la dame avance bien en diagonale
			if ($xd<$xa){
				$sensa=1;
//cherches le sens en x
			}else{
				$sensa=-1;
			}
			if ($yd<$ya){
// le sens en y
				$sensb=1;
			}else{
				$sensb=-1;
			}
			$a=$xd+$sensa;
			$b=$yd+$sensb;
			for ($i=0;$i<$taille-1;$i++){
//echo "$a, $b <br>";
				if ($case[$b*8+$a]!=='no'){
					return 0;
/*
$j=$case[$b*8+$a];
echo "$j en ($a, $b)<br>";
*/
				}
				$a+=$sensa;
				$b+=$sensb;
			}
		}else if ($xd===$xa){
//Si la dame se dplace en ordone
			if ($yd > $ya){
//On tri (pour la boucle)
				$a=$ya;
				$ya=$yd;
				$yd=$a;
			}
			for ($a=$yd+1;$a<$ya;$a++){
//On vrifie qu'il n'y a rien sur le passage de la dame
				if ($case[$a*8+$xa]!=='no'){
					return 0;
				}
			}
		}else if ($yd===$ya){
//Si la dame se dplace en abscisse
			if ($xd > $xa){
//on tri (pour la boucle)
				$a=$xa;
				$xa=$xd;
				$xd=$a;
			}
			for ($a=$xd+1;$a<$xa;$a++){
//On vrifie qu'il n'y a rien sur le pasage de la Dame
				if ($case[$ya*8+$a]!=='no'){
					return 0;
				}
			}
		}else{
			return 0;
		}
	}else if($piece==='p'){
//Si c'est un pion
//echo "Pion<br>";
		if ($couleur==='n'){
			if ($case[$jusqua]!=='no'){
//prise
				if (($ya!==$yd+1)||($xa!==$xd-1 && $xa!==$xd+1))
					return 0;
			}else{
				if ($xa === $xd){
					if (($ya !== $yd+1) && ($ya !== $yd+2 || $case[$yd*8+8+$xd]!=='no' || $yd!==1))
						return 0;
				}else{
					$possible=0;
//gestion de la prise en passant...
					if ($case[$xa+$yd*8]==='pb'){
						foreach ($coupsjoues as $coup){
//echo "$coup<br>";
							$p2=substr($coup, 0, 1);
//Pour les prises en passant, il faut savoir quel pion a t avanc, savoir si il a bien t avanc de deux cases...
							$xd2=substr($coup, 2, 1);
							$yd2=substr($coup, 4, 1);
							$xa2=substr($coup, 6, 1);
							$ya2=substr($coup, 8, 1);
							if ($p2==='p' && $xd2===$xa && $yd===$ya2 && $yd2===6){
								$possible=2;
							}
						}
					}
				}
			}
		}else{
			if ($case[$jusqua]!=='no'){
//prise
				if (($ya!==$yd-1)||($xa!==$xd-1 && $xa!==$xd+1))
					return 0;
			}else{
				if ($xa === $xd){
					if (($ya !== $yd-1) && ($ya !== $yd-2 || $case[$yd*8-8+$xd]!=='no' || $yd!==6))
						return 0;
				}else{
					$possible=0;
//gestion de la prise en passant
					if ($case[$xa+$yd*8]==='pn')
						foreach ($coupsjoues as $coup){
							$p2=substr($coup, 0, 1);
							$xd2=substr($coup, 2, 1);
							$yd2=substr($coup, 4, 1);
							$xa2=substr($coup, 6, 1);
							$ya2=substr($coup, 8, 1);
							if ($p2==='p' && $xd2===$xa && $yd===$ya2 && $yd2===1)
								$possible=2;
						}
				}
			}
		}
	}else
	//Sinon, alors on a pas touch la bonne case...
		return 0;
	//On ne peut pas roquer quand on passe par un chec...
	if ($possible===3 || $possible===4){
		if (($possible===3 && $couleur==='b') || ($possible===4 && $couleur==='n'))
			for ($i=$de;$i<$jusqua;$i++)
				$case[$i]='r'.$couleur;
		else
			for ($i=$de;$i>$jusqua+1;$i--)
				$case[$i]='r'.$couleur;
		if (isinchess($case2, $couleur, $coupsjoues)===1)
			return 0;
	}
	return($possible);		//retour de fonction
}

function joue($case, $de, $jusqua, $couptest, $couleur){
/*
Fonction qui fait jouer un coup sur l'chiquier
*/
	if ($couptest===1){
		$case[$jusqua]=$case[$de];
		$case[$de]='no';
	}else if ($couptest===2){
		$yd=$de-$de%8;
		$xa=$jusqua%8;
		$case[$jusqua]=$case[$de];
		$case[$xa+$yd]='no';
		$case[$de]='no';
	}else if ($couptest===3){
		$xd=$de%8;
		$yd=($de-$xd)/8;
		$xa=$jusqua%8;
		$case[$jusqua]='r'.$couleur;
		$case[$yd*8+$xd-1]='t'.$couleur;
		$case[$de]='no';
		$case[$yd*8]='no';
	}else{
		$xd=$de%8;
		$yd=($de-$xd)/8;
		$xa=$jusqua%8;
		$case[$jusqua]='r'.$couleur;
		$case[$yd*8+$xd+1]='t'.$couleur;
		$case[$de]='no';
		$case[$yd*8+7]='no';
	}
	return $case;
}

function enreg($promo, $partie, $joueur1, $joueur2, $case, $tempsminutes1, $tempsminutes2, $tempssecondes1, $tempssecondes2, $date, $nombre, $mustplay, $coupsjoues, $replique){
/*
Fonction qui enregistre l'tat de la partie
*/
	$fp=fopen('parties/'.$partie.'.php','w');
	fputs($fp,'<?php
	$joueur1=\''.$joueur1.'\';
	$joueur2=\''.$joueur2.'\';
	$case=array(');
	for ($i=0;$i<63;$i++){
		fputs($fp,'\''.$case[$i].'\',');
		if ($i%8===0)
			fputs($fp,'
			');
	}
	fputs($fp,'\''.$case[63].'\');
	$tempsminutes1='.$tempsminutes1.';
	$tempsminutes2='.$tempsminutes2.';
	$tempssecondes1='.$tempssecondes1.';
	$tempssecondes2='.$tempssecondes2.';
	$depuis=\''.$date.'\';
	$nombre='.$nombre.';
	$mustplay='.$mustplay.';
	$coupsjoues=array(');
	for ($i=0;$i<$nombre-1;$i++){
		fputs($fp,'\''.$coupsjoues[$i].'\',');
		if ($i%8===0)
			fputs($fp,'
                        ');
	}
	$i=$nombre-1;
	fputs($fp,'\''.$coupsjoues[$i].'\');
        $replique=array(');
	for ($i=0;$i<4;$i++){
		$j= $var=addslashes($replique[$i]);
		fputs($fp,'\''.$j.'\',');
	}
	$j= addslashes($replique[5]);
	fputs($fp,'\''.$j.'\');
        $promo='.$promo.';
        ?>');
	fclose($fp);
}

function htmlise($var){
	/*
	Fonction qui transforme un texte brute ne texte affichable  l'cran
	*/
	/*$var = str_replace('<', '&lt', $var);
	$var = str_replace('>', '&gt', $var);
	$var = ereg_replace('[\]', '', $var);*/
	$var=htmlentities($var);
	$var=nl2br($var);
	return($var);
}

function secondes(){
/*
Fonction qui renvoi le nombre de secondes coules depuis le premier janvier 1970
(date de dpart des systmes unix, donc de leur horloge)
*/
   list($usec, $sec) = explode(' ', microtime());
   return ($sec);
}

$msg='';						//Quelques messages style echec coup invalide ect...
$addtexte=$_POST['texte'];				//lors des tchats
$text=$_GET['text'];					//idem
$abandon=$_GET['abandon'];				//si on abandonne
$promotion=$_GET['promotion'];				//pour les promotions (quand un pion arrive en colone 1 u 8)
$de=(int)$_GET['de'];					//case de dpart
$jusqua=(int)$_GET['a'];					//case d'arrive
$partie=$_GET['partie'];				//partie en cours
session_start();					//on lance les sessions pour accder aux logins et passwords
if (!empty($_SESSION['login'])){
	$login=$_SESSION['login'];				//On rcupre le login sur la session
	$password=$_SESSION['password'];			//idem pour le pass
}else{								//si la session ne contient pas de login,
	$login= $_COOKIE['login'];				//alors il peut tre stoqu en coockie
	$password= $_COOKIE['password'];			//avec le mot de passe
}
/*
J'ai prfr rcuprer ceci par cookie pour que ce ne soit pas affich dans la barre dtat...
de est la case de dpart
a est la case d'arrive
partie est le numrot de la partie
promotion sert lorsqu'un pion arrives en fin d'chiquier
abandon sert lorsque l'on abandonne
text et texte servent pour le tchat
*/
if (file_exists('parties/'.$partie.'.php')){		//si la partie existe bien
	$i=1;
	$ERREUR=0;
}else{
	$ERREUR=1;					//ce code d'erruer permet de savoir quoi afficher  la fin
	$i=0;
}
$f='../logins/'.$login.'.php';		//on fait une petite optimisation
if (file_exists($f)){			//si le login existe bien
	include($f);
}else{
	$ERREUR=2;					//sinon, on sait aussi quoi afficher
	$monpass='';
	$i=0;
}
//a cause des sessions, on ne peut pas le mettre en haut...
echo '
<html>
<head>
<title>Jeu d\'chec</title>
<link rel="Stylesheet" href="../site.css" type="text/css">
</head>
<body>';

if ($password===$monpass && $i===1 && !empty($partie)){
	include('parties/'.$partie.'.php');
	//gestion du texte
	if ($text===1){
	//si on tchate
		$addtexte=$login.' : '.$addtexte;		//le texte  afficher est sous la forme dcrite ici
		$addtexte=htmlise($addtexte);			//on traite le texte
		for ($i=5;$i>0;$i--)				//on dcale les rpliques
			$replique[$i]=$replique[$i-1];
		$replique[0]=$addtexte;				//on place la rplique en cours
		enreg($promo, $partie, $joueur1, $joueur2, $case, $tempsminutes1, $tempsminutes2, $tempssecondes1, $tempssecondes2, $depuis, $nombre, $mustplay, $coupsjoues, $replique);
		//et on sauvegarde
	}
	//gestion des abandons
	if ($abandon===1){
		//on indique  la personne qu'il a abandonn
		$msg=$msg.'Vous avez abandonn<br>';
		if ($login===$joueur1)		//on doit chercher qui a perdu pour suprimer son roi de l'chiquier
			for ($i=0;$i<64;$i++)
				if ($case[$i]=='rb')
					$case[$i]='no';
				
		else
			for ($i=0;$i<64;$i++)
				if ($case[$i]=='rn')
					$case[$i]='no';
		$mustplay=3;			//indique que plus personne ne doit jouer
		enreg($promo, $partie, $joueur1, $joueur2, $case, $tempsminutes1, $tempsminutes2, $tempssecondes1, $tempssecondes2, $depuis, $nombre, $mustplay, $coupsjoues, $replique);
		enregperte($case,$joueur1,$joueur2);
		/*
		ici, on enregistre le fichier de partie
		puis les fichiers login pour leur compter une partie de plus de perdue ou gagne
		*/
	}
	$jou=0;
	if ($login===$joueur1){
		$couleurdujoueur='blancs';
		$autre=2;
	}else{
		$couleurdujoueur='noirs';
		$autre=1;
	}
	if (
		($mustplay===1 && $couleurdujoueur==='blancs')||
		($mustplay===2 && $couleurdujoueur==='noirs')
		){
			$atoi=1;
	}else{
		$atoi=0;
	}
	$c=substr($couleurdujoueur,0,1);
	//regarde si on n'a le droit  une promotion
	if (($promo===1) && !empty($promotion)){
		//si on a jou une promotion alors on doit apliquer les changements
		if ($promotion === 't' || $promotion === 'c' || $promotion === 'f' || $promotion === 'd'){ 
			for ($i=0;$i<8;$i++){
				if ($case[$i]==='p'.$c)
					$case[$i]=$promotion.$c;
				if ($case[$i+56]==='p'.$c)
					$case[$i+56]=$promotion.$c;
			}
			//indique qu'on n'a plus le droit aux promotions
			$promo=0;
			//puis fait le dcompte du temps
			$date=secondes();
			$secodesentre=$depuis-$date;
			$secondes=$secodesentre%60;
			$minutes=($secodesentre-$secondes)/60;
			//echo "$minutes, $secondes<br>";
			if ($couleurdujoueur==='blancs'){
				$tempsminutes1-=$minutes;
				$tempssecondes1-=$secondes;
				if ($tempssecondes1<0){
					$tempssecondes1+=60;
					$tempsminutes1--;
				}
			}else{
				$tempsminutes2-=$minutes;
				$tempssecondes2-=$secondes;
				if ($tempssecondes2<0){
					$tempssecondes2+=60;
					$tempsminutes2--;
				}
			}	
			enreg($promo, $partie, $joueur1, $joueur2, $case, $tempsminutes1, $tempsminutes2, $tempssecondes1, $tempssecondes2, $date, $nombre, $autre, $coupsjoues, $replique);
			$atoi=0;
		}else{
			/*
			si on n'a demand une promotion d'une pice qui ne peut tre sujet de promotion
			(roi, pion, ou mme un caractre qui n'ai rien en raport avec une pice d'chec,
			ici, on peut mme refuser les mots
			*/
			$msg=$msg.'Piece non valide..<br>';
		}
	}
	if ((!empty($de) || !empty($jusqua)) && $promo===0){	//si on a post un coup autre que promotion
		if ($atoi===1){		//si c'est  nous de jouer
			/*
			Teste si le coup est valide,
			si il ne l'est pas, le retour de la fonction sera 0
			*/
			$couptest=possible(1, $couleurdujoueur,$case, $de, $jusqua, $coupsjoues);
			if ($couptest>0){
				$date=secondes();			//fait le dcompte du temps
				$secodesentre=$date-$depuis;
				$secondes=$secodesentre%60;
				$minutes=($secodesentre-$secondes)/60;
				//echo "$minutes, $secondes<br>";
				$perduautemps=0;			//indique qu'on a pas perdu au temps
				if ($couleurdujoueur==='blancs'){
				//cherche la couleur pour dcompter  la bonne personne
					$tempsminutes1-=$minutes;	//puis fait vraiment le dcompte
					$tempssecondes1-=$secondes;
					if ($tempssecondes1<0){		//les retenues
						$tempssecondes1+=60;
						$tempsminutes1--;
					}
					if ($tempsminutes1<0){		//les pertes
						$perduautemps=1;
					}
				}else{
					$tempsminutes2-=$minutes;
					$tempssecondes2-=$secondes;
					if ($tempssecondes2<0){
						$tempssecondes2+=60;
						$tempsminutes2--;
					}
					if ($tempsminutes2<0){
						$perduautemps=1;
					}
				}
//Si on a pas perdu au temps alors on joue
				if ($perduautemps===0){
//On commence par enregistrer le drnier coups jou...
					$nombre++;
					$piece=substr($case[$de],0,1);
					$xd=$de%8;
					$yd=($de-$xd)/8;
					$xa=$jusqua%8;
					$ya=($jusqua-$xa)/8;
					//gre les promotions
					if ($piece==='p' &&($ya===0 || $ya===7))
					{
						$promo=1;
						$autre=$mustplay;	//change de joueur
					}
					/*
					Ensuite, il doit noter les coups comme en comptition
					pour le dplacement d'un pion, on met juste la case d'arrive,
					pour le dplacement d'une autre pice, on met l'initiale de la pice en majuscule et la case d'arrive
					pour la prise par un pion, on met la lettre de la case de dpart, une croix et la case d'arrive.
					Pour la prise par une autre pice, on met l'initiale de la pice en majuscule, une croix et la case d'arrive
					Pour un petit roque, on note O-O
					Pour un grand roque, on note O-O-O
					Lorsqu'il y a chec, on ajoute un plus  la fin
					Lorsqu'il y a mat, on met un dise  la fin
					On dclare alors un tableau de cases en abscices
					*/
					$tabcases=array('a','b','c','d','e','f','g');
					if ($couptest<3){
					//Si c'est un dplcement classique ou une prise en passant
						if ($piece==='p')	//si c'est un pion
						/*
						si il y a une prise alors on n'a un caractre qui dsigne
						la pice ($p) : c'est la lettre de la case de dpart.
						L'atribut est le caractre croix.
						sinon, on n'a pas ce caractre ($p='';) et pas d'atribut.
						*/
							if ($case[$jusqua]==='no'){
								$p='';
								$attribut=' ';
							}else{
								$p=$tabcases[$xd];
								$attribut='*';
							}
						else{
						//si la pice est classique, alors on met son initiale en majuscule
							$p=Strtoupper($piece);
							//et on regarde si il y a une prise.
							if ($case[$jusqua]==='no')
								$attribut=' ';
							else
								$attribut='*';
						}
						$yp=8-$ya;	//l'ordone rle...
						//puis on enregistre le nom du coup
						$coupenluimeme=$p.$attribut.$tabcases[$xa].$yp;
					//si c'est un roque
					}else if ($couptest===3)
						$coupenluimeme='O-O';
					else if ($couptest===4)
						$coupenluimeme='O-O-O';
//Faut quand mme faire jouer le coup ^^
					$case=joue($case, $de, $jusqua, $couptest,substr($couleurdujoueur,0,1));
					$coupsjoues[$nombre-1]=$piece.'.'.$xd.'.'.$yd.'.'.$xa.'.'.$ya.'.'.$coupenluimeme;
/*
Pour commencer je note la pice,
puis X dpart puis Y depart
puis X arrive puis Y arrive
puis ce qui sera affich...
le tout spar par des points...
J'ai pris la peine de faire enregistrer les coups au format franais
En comptition, on note comme cela les coups...
*/
					enreg($promo, $partie, $joueur1, $joueur2, $case, $tempsminutes1, $tempsminutes2, $tempssecondes1, $tempssecondes2, $date, $nombre, $autre, $coupsjoues, $replique);
					//fonction qui enregistre le fichier de sauvegarde de la partie.
					$atoi=0;
				}else{
//Si on ne joue pas c'est que l'on a perdu au temps
					if ($tempsminutes2<0){
					//si les noirs ont perdu alors on suprime leur roi de l'chiquier
						for ($i=0;$i<64;$i++)
							if ($case[$i]==='rn')
								$case[$i]='no';
						if ($couleurdujoueur==='noirs')
							$msg=$msg.'Vous avez perdu au temps<br>Fin de partie... U lose...<br>';
						else
							$msg=$msg.'Vous avez gagn au temps<br>Fin de partie... U win..<br>';
						$mustplay=3;		//indique que plus personne ne doit jouer
						enreg($promo, $partie, $joueur1, $joueur2, $case, $tempsminutes1, $tempsminutes2, $tempssecondes1, $tempssecondes2, $date, $nombre, $mustplay, $coupsjoues, $replique);
						enregperte($case,$joueur1,$joueur2);
					}else{
					//sinon, alros ce sont les blancs qui ont perdu, on suprime alors leur
					//roi de l'chiquier
						for ($i=0;$i<64;$i++)
							if ($case[$i]=='rb')
								$case[$i]='no';
//Il faut bien afficher lorsque l'on a perdu au temps...
						if ($couleurdujoueur==='blancs')
							$msg=$msg.'Vous avez PERDU au TEMPS<br>Fin de partie... U lose...<br>';
						else
							$msg=$msg.'Vous avez gagn au TEMPS<br>Fin de partie... U win..<br>';
						$mustplay=3;
						enreg($promo, $partie, $joueur1, $joueur2, $case, $tempsminutes1, $tempsminutes2, $tempssecondes1, $tempssecondes2, $date, $nombre, $mustplay, $coupsjoues, $replique);
						enregperte($case,$joueur1,$joueur2);
					}
				}
			}else
				$msg=$msg.'<br>Coup non autoris...';
				/*
				Je n'ai pas mis les dtails sur les coups non autoriss,
				mais je ne penses pas que l'on en ai vraiment besoin...
				Suffit de regarder l'chiquier pour savoir ce qui se passe...
				On indique seulement qu'il est interdit
				*/
		}else
			$msg=$msg.'<hr>Ce n\'est pas ton tour, attends un peu !';
			//indique  la personne qu'il n'a pas le droit de jouer sur le moment
	}
	$perdunoir=1;
	$perdublanc=1;
	/*
	Cherches si un joueur a perdu...
	Je fais seulement une recherhce des rois...
	Si un joueur perds on enlve son roi...
	Si il y a nulle, alors on enlve les deux rois...
	*/
	for ($i=0;$i<64;$i++){
		if ($case[$i]==='rn')
			$perdunoir=0;
		if ($case[$i]==='rb')
			$perdublanc=0;
	}
	if ($atoi===1 && $perdunoir===0 && $perdublanc===0)
	{
		//cherches si on est chec, pat ou mat.
		$et=etat($case, $couleurdujoueur, $coupsjoues);
		if ($et===1)
			//indique un chec
			$msg=$msg.'Vous tes chec<br>';
		else if ($et===2)
		{
			//indique un mat, enlve le roi du perdant, indique que la partie est finit et sauvegarde
			$msg=$msg.'Vous tes mat...<br>';
			if ($login==$joueur1){
				for ($i=0;$i<64;$i++)
					if ($case[$i]=='rb')
						$case[$i]='no';
			}else{
				for ($i=0;$i<64;$i++)
					if ($case[$i]=='rn')
						$case[$i]='no';	
			}
			$mustplay=3;
			enreg($promo, $partie, $joueur1, $joueur2, $case, $tempsminutes1, $tempsminutes2, $tempssecondes1, $tempssecondes2, $depuis, $nombre, $mustplay, $coupsjoues, $replique);
			enregperte($case,$joueur1,$joueur2);
		}else if ($et==3){
			$msg=$msg.'Il y a pat...<br>';
			/*
			Lorsqu'il y a pat, personne ne perd, alors on supprimes les deux rois...
			On enregistre videment
			on indique aussi qu'on ne doit plus jouer
			*/
			for ($i=0;$i<64;$i++){
				if ($case[$i]=='rb')
					$case[$i]='no';
				if ($case[$i]=='rn')
					$case[$i]='no';
			}
			$mustplay=3;
			enreg($promo, $partie, $joueur1, $joueur2, $case, $tempsminutes1, $tempsminutes2, $tempssecondes1, $tempssecondes2, $depuis, $nombre, $mustplay, $coupsjoues, $replique);
		}/*else{
			echo 'action simple';
		}*/
	}
	if ($atoi===0 && $mustplay!==3){				//si ne n'est pas  toi de jouer et que la partie n'est pas termine
		$date=secondes();					//on rcupre le nombre de seconde
		$secodesentre=$date-$depuis;				//calcule les secondes coules depuis
									//que l'autre ne s'est pas connect
		if ($couleurdujoueur==='blancs'){			//si tu as les blancs
			$temps=$tempsminutes2*60+$tempssecondes2;
			//on calcule le nombre de seconde auquel on avait droit pour jouer/
		}else{
			$temps=$tempsminutes1*60+$tempssecondes1;
		}
		if ($secodesentre>$temps){				//si on a perdu au temps alors
			$msg=$msg.'Il a perdu au temps<br>';
			if ($login===$joueur1){
				for ($i=0;$i<64;$i++)
					if ($case[$i]==='rn')
						$case[$i]='no';
			}else{
				for ($i=0;$i<64;$i++)
					if ($case[$i]==='rb')
						$case[$i]='no';	
			}
//Si mustplay = 3 alors la partie est termine depuis plus d'un tour et on a enregistr les scores...
			$mustplay=3;
			enreg($promo, $partie, $joueur1, $joueur2, $case, $tempsminutes1, $tempsminutes2, $tempssecondes1, $tempssecondes2, $depuis, $nombre, $mustplay, $coupsjoues, $replique);
			enregperte($case,$joueur1,$joueur2);
		}
	}
	$gui='"';
	//affichage de l'chiquier... Il faut que les pions du joueur soient en bas
	echo '<table border="0" width="100%">
	<tr><td width="50%">';
	if ($promo===0 || $atoi===0){		//si on n'a une promotion alors on n'affiche pas a
		echo '<div style="position:absolute;left:0;top:0;">
		<table border="0" width="400" height="400">
		<tr>';
//affichage des cases
		$coul=0;
		for ($i=0;$i<64;$i++){
			if ($couleurdujoueur==='blancs')
				$j=$i;
			else
				$j=63-$i;			//inverse l'chiquier en fonction de la couleur
			if ($i%8==0 && $i!=0)
				echo '</tr><tr>';
			else
				$coul++;			//change la souleur de la case suivante
			if ($coul%2==0)			//calcule la couleur des cases
				$couleur='555555';		//une sur deux sera d'un gris fonc
			else
				$couleur='BBBBBB';		//une sur deux d'un gris clair
			echo '<td width="20" height="20" bgcolor="#',$couleur,'"';
			if ($perdublanc===0 && $perdunoir===0 && $atoi===1) echo ' onclick="joue(',$j,')"';
			echo '><img src="images/',$case[$j],'.png" title="cliquez pour jouer" /></td>';
		}
		echo '</tr>
		</table>
		</div>';
	}else{
		$c=substr($couleurdujoueur,0,1);		//cherche la couleur pour afficher les promotions
		/*
		donc, voici l'interface de promotions
		une ligne, et un tableau de liens et d'images
		*/
		echo '<hr>
		<table border="1" width="100%" bgcolor="#777777">
			<tr>
				<td>
					<a href="jouer.php?partie=',$partie,'&promotion=t">
						<img src="images/t',$c,'.png" title="tour" />
					</a>
				</td>
				<td>
					<a href="jouer.php?partie=',$partie,'&promotion=c">
						<img src="images/c',$c,'.png" title="cavalier" />
					</a>
				</td>
				<td>
					<a href="jouer.php?partie=',$partie,'&promotion=f">
						<img src="images/f',$c,'.png" title="fou" />
					</a>
				</td>
				<td>
					<a href="jouer.php?partie=',$partie,'&promotion=d">
						<img src="images/d',$c,'.png" title="dame" />
					</a>
				</td>
			</tr>
		</table>';
	}
	/*
	On doit rcuper les infos sur chaque joueur...
	Les includes sont les meilleurs faons de procder sans mysql...
	*/
	include('../logins/'.$joueur1.'.php');
	$perdu1=$partielose;
	$gagne1=$partiewin;
	$avatar1=$avatar;
	include('../logins/'.$joueur2.'.php');
	$perdu2=$partielose;
	$gagne2=$partiewin;
	$avatar2=$avatar;
	include('../logins/'.$login.'.php');
	/*
	On va afficher les tableaux rcapitulatifs des performances des deux joueurs...
	Je n'ai pas fait de classements elo car je ne sais pas comment on les calcule...	
	*/
	echo '</td><td>
	<table border= "0" width="80%">
	<tr>
	  <td>Bienvenu : <em>',$login,'</em></td>
	  <td>Vous avez les ',$couleurdujoueur,'</td>
	</tr>
	</table>
	<table border="1" width="100%">
	<tr>
	  <td>dtails</td>
	  <td bgcolor="77AAFF">blancs</td>
	  <td bgcolor="FFAA77">noirs</td>
	</tr>
	<tr>
	  <td>joueurs</td>
	  <td bgcolor="77AAFF">',$joueur1,'</td>
	  <td bgcolor="FFAA77">',$joueur2,'</td>
	</tr>
	<tr>
	  <td>nbr de victoires</td>
	  <td bgcolor="77AAFF">',$gagne1,'</td>
	  <td bgcolor="FFAA77">',$gagne2,'</td>
	</tr>
	<tr>
	  <td>nbr de dfaites</td>
	  <td bgcolor="77AAFF">',$perdu1,'</td>
	  <td bgcolor="FFAA77">',$perdu2,'</td>
	</tr>
	<tr>
	  <td>minutes restantes</td>
	  <td bgcolor="77AAFF">',$tempsminutes1,'</td>
	  <td bgcolor="FFAA77">',$tempsminutes2,'</td>
	</tr>
	<tr>
	  <td>secondes restantes</td>
	  <td bgcolor="77AAFF">',$tempssecondes1,'</td>
	  <td bgcolor="FFAA77">',$tempssecondes2,'</td>
	</tr>
	<tr>
	  <td>Photos</td>
	  <td><img src="../',$avatar1,'" /></td>
	  <td><img src="../',$avatar2,'" /></td>
	</tr>
	<tr>
	  <td>informations sur les joueurs</td>
	  <td><a href="aff_profile.php?joueur=',$joueur1,'" target="_blank">Afficher le profil</a></td>
	  <td><a href="aff_profile.php?joueur=',$joueur2,'" target="_blank">Afficher le profil</a></td>
	</tr>
	</table>';
	/*
	Ici, on va crit quelques infos...
	*/
	if ($perdublanc===0 && $perdunoir===0){
		if ($atoi==0)					//affiche qui doit jouer
			echo '<br />C\'est  lui de jouer...';
		else
			echo '<br />C\'est  toi de jouer...';
	}else if ($perdublanc===1 && $perdunoir===1)
		if (substr_count($msg,'perdu au temps')===0)		//qui a perdu au temp
//J'ai remarqu que lors des pertes au temps, les parties nules taient dcrts... et de toute faon dja affichs...
			echo '<br />Partie nulle...';
	else if($perdublanc===1)
		if ($couleurdujoueur==='blancs')		//cherche qui a gagn ou perdu
			echo '<br />Vous avez perdu...';
		else
			echo '<br />vous avez gagn!!';
	else if ($perdunoir===1)
		if ($couleurdujoueur==='blancs')
			echo '<br />Vous avez gagn!!!';
		else
			echo '<br />vous avez perdu...';
	/*
	On commence par crire les messages (style c pas ton tour, ou coup interdit etc...)
	puis on crit les rpliques...
	*/
	if ($perdublanc===1 || $perdunoir===1){
        	//proposes une nouvelle partie
		echo '<br /><a href="index.php">commencer une nouvelle partie</a><br />';
	}else{
        	//ou un abandon
		echo '<br /><input type="button" value="adandonner" onclick="abandon();" />';
	}
	echo '<br />',$msg,'
	<center>
	<table border="1" width="90%">
		<tr><td bgcolor="#AAAAAA">';
	for ($i=0;$i<5;$i++){
		echo $replique[$i],'<br />';		//On crit tout ce qui s'est dit...
	}
	//Ici on crit le formulaire pour envoyer un message
	echo $replique[5],
		'<hr />
		<form method="post" name="formulaire" action="jouer.php?partie=',$partie,'&text=1">
			dire :<input type="text" name="texte" size="20" />
			<input type="submit" value="OK" />
		</form>
		</td>
	</tr>
	</table>
	</center>
	liste des coups:
	</td>
	</tr>
	</table>
	<table border="1">
	<tr><td bgcolor="#77AAFF">';
	//Ici, on crit la liste des coups dja jous
	for ($i=0;$i<$nombre;$i++){
		$coup=substr($coupsjoues[$i],10,strlen($coupsjoues[$i])-10);
//la partie affiche n'est qu'un extrait de la partie enregistre...
		echo $coup;
		if ($i%2===1){
			echo '<br />';		//les sparateurs de coups... celui ci est videment le sparateur verticale
		}else{
			echo ' -//-';		//et celui ci l'orisontale
		}
	}
	//Ici, on crit les fonctions javascript : dplacement des pices + ractualisation...
	echo '
	</td>
	</tr>
	</table>
	<script language ="javascript" type="text/javascript">
	function redir(temps){
		setTimeout(\' redir2(\'+temps+\');\' , temps*1000);
	}
	
	function redir2(temps){
		if (document.formulaire.texte.value==\'\'){
		    window.location.href=\'jouer.php?partie='.$partie.'\';
		}else{
		    redir(temps);
		}
	}
	</script>';
	//Si on a pedu alors le dplacement des pices est inutile...
	if ($perdublanc===0 && $perdunoir===0){		//tant que personne n'a perdu
		if ($atoi===1){				//on n'affiche les curseurs de dplacements uniquement lorsque l'on doit jouer
			echo '
				<div style="position:absolute;display:none;" id="1">
				  <img src="images/curseur_1.png" />
				</div>
				<div style="position:absolute;display:none;" id="2">
				  <img src="images/curseur_2.png" />
				</div>
				<script language="javascript" type="text/javascript">
					//Fonction qui sert  faire changer le status et le titre lorsque la personne doit jouer...
					function te(Message, i){
						j=i+50;
						if (j>Message.length)
							j=Message.length;
						var strStatus=Message.substring(i,j)
						i++;
						if(i>Message.length)
							i=0;
						window.status=strStatus;
						document.title=strStatus;
						setTimeout(\'te("\' + Message + \'", \' + i + \');\', 100);
					}
					te("C\'est  toi de jouer...", 0);
					function abandon(){
						window.location.href=\'jouer.php?partie='.$partie.'&abandon=1\';
					}
					i=0;
					function joue(case_joue){
						i++;
						if (i==1){
							case1=case_joue;
						}else{
							case2=case_joue;
						}';
			if ($couleurdujoueur==='noirs')
				echo 'case_joue=63-case_joue;';
//Comme on tourne le plateau, (noirs/blancs) il faut que les pions soit aussi tourns...
					echo '
						x_case=case_joue%8;
						y_case=(case_joue-x_case)/8;
						document.getElementById(i).style.display=\'\';
						document.getElementById(i).style.left=x_case*50+10;
						document.getElementById(i).style.top=y_case*50+10;
						if (i==2){
							setTimeout('.$gui.' window.location.href=\'jouer.php?partie='.$partie.'&de=\'+case1+\'&a=\'+case2'.$gui.', 500);
						}
				}
				redir(20);
			</script>';
			//Pour te tchat il faut quand mme metre une ractualisation
		}else
		//Pour savoir quand l'autre a jou il faut mettre une ractualisation
		echo '<script type="text/javascript" langage="javascript">
			redir(5);
			</script>';
	}else
		//Pour le tchat, il faut quand mme mettre une ractualisation...
		echo '<script type="text/javascript" langage="javascript">
		redir(10);
		</script>';
}else{
//Si l'identification ne s'est pas faite... Ou que la partie n'existe pas...
	if ($ERREUR===1)
		echo '<p class="erreur">Une page prcdente aurait du vous emmener ici tout en spcifiant une partie, or, vous n\'avez pas du passer par cette prcdente page...</p><br><a href="../index.php">Retour  l\'acceuil.</a><hr>';
	else if ($ERREUR===2)
			echo '<p class="erreur">Vous n\'tes pas logu, or vous devez tre identifi...</p><br><a href="../index.php">Allez ici pour vous connecter...</a><hr>';
	else
		echo '<p class="erreur">Votre mot de passe est incorect...</p><br><a href="../index.php">Allez ici pour vos identifier...</a><hr>';
}
?>
<center>
(copyleft) coucou747<br>
mail : <a href="mailto:coucou747@hotmail.com">coucou747@hotmail.com</a> site : <a href="http://coucou747.hopto.org">http://coucou747.hopto.org</a>
<hr>
Bon divertissement.
</center>
</body>
</html>

